/*********************************************************************
*项目名称:MG82F6B08_001_104-DEMO
*			测试板使用 MG82F6B08_001_104 SOP16_V11 EV Board (TH221A)
*			CpuCLK=8MHz, SysCLK=8MHz
*功能描述：
*			串口0，LIN Slave
*注意事项：
*
*建立时间:
*修改日志:
*    
*********************************************************************/
#define _MAIN_C

#include <Intrins.h>
#include <Absacc.h>

#include <Stdio.h>  // for printf

#include ".\include\REG_MG82F6B08_001_104.H"
#include ".\include\Type.h"
#include ".\include\API_Macro_MG82F6B08_001_104.H"
#include ".\include\API_Uart_BRGRL_MG82F6B08_001_104.H"


/*************************************************
*定义系统时钟SysClk (MAX.24MHz)
*可选: 
*	8000000,16000000
*	11059200,22118400
*************************************************/
#define MCU_SYSCLK		8000000
/*************************************************/
/*************************************************
*定义CPU时钟 CpuClk (MAX.16MHz)
*	1) CpuCLK=SysCLK
*	2) CpuClk=SysClk/2
*************************************************/
#define MCU_CPUCLK		(MCU_SYSCLK)
//#define MCU_CPUCLK		(MCU_SYSCLK/2)

#define TIMER_1T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) /256) 			
#define TIMER_1T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) %256)

#define TIMER_12T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) /256) 			
#define TIMER_12T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) %256)

#define LED_R		P32
#define LED_G_0		P33
#define LED_G_1		P46
#define LIN_TXD			P31
#define LIN_RXD			P30

#define LIN_TIME_MAX				10

#define LIN_SYNC_BYTE				0x55

#define LIN_AUTO_BAUDRATE_FLAG		0		// 0->禁止自动校准波特率             1->使能自动校准波特率			

#define LIN_PID_MASTER_TX_MSG0		0x10		
#define LIN_PID_MASTER_TX_MSG1		0x11	

#define LIN_PID_MASTER_RX_MSG0		0x21
#define LIN_PID_MASTER_RX_MSG1		0x31

// 定义LIN状态
typedef enum
{
  LIN_IDLE_BREAK=0,
  LIN_SYNC,
  LIN_PID,
  LIN_MASTER_RX_DATA,
  LIN_MASTER_RX_CHECKSUM,
  LIN_MASTER_RX_DONE,
  LIN_MASTER_TX_DATA,
  LIN_MASTER_TX_CHECKSUM,
  LIN_MASTER_TX_DONE,
  LIN_ERR
}LIN_State;

// 定义LIN模式
typedef enum
{
  	LIN_MODE_MASTER_TX=0,
	LIN_MODE_MASTER_RX,
	LIN_MODE_SLAVE_TX,
	LIN_MODE_SLAVE_RX
}LIN_Mode;

// 定义帧结构体
typedef struct
{
	LIN_Mode Mode;
  	LIN_State State;
  	u8 PID ;
  	u8 Data[8];
  	u8 DataLength;
  	u8 DataInx;
  	u8 Check;
} LIN_Frame ;

#define BIT(A,B)      ((A>>B)&0x01)   // A 为变量 

idata LIN_Frame LINFrame;

// 定义从机PID( 经校验后的值)
typedef struct
{
  	u8 SPIDMTx0_P;		// 从机PID 0,用于主发从收
  	u8 SPIDMTx1_P;		// 从机PID 1,用于主发从收
  	u8 SPIDMRx0_P;		// 从机PID 0,用于主收从发
  	u8 SPIDMRx1_P;		// 从机PID 1,用于主收从发
} LIN_SlavePID_Def ;
idata LIN_SlavePID_Def LINSlavePID;

u8 LedTime;
u8 LINOverTime;

void LIN_Slave_StartFrame(void);
u8 LIN_CalcParity(u8 id);
u8 LIN_CalcChecksum(u8 id,u8 *lindata,u8 length);
u8 LIN_CalcChecksum_INT(u8 id,u8 *lindata,u8 length);

/***********************************************************************************
*函数名称:	u8 LIN_CalcChecksum_INT(uint8 id,uint8 *data,uint8 length)
*功能描述: LIN校验和计算 （用在串口接收中断）
*输入参数:	
*返回参数:	  
*************************************************************************************/
u8 LIN_CalcChecksum_INT(u8 id,u8 *lindata,u8 length)
{
	u8 i;
	u16 check_sum = 0;
	//0x3C 0x3D 使用标准型校验
	if(id != 0x3c && id != 0x7d)  //使用增强型校验
	{
	 	check_sum  = id ;
	} 
	else //使用标准校验
	{
	 	check_sum = 0 ;
	}
	for (i = 0; i < length; i++) 
	{    
	  	check_sum += *(lindata++);
	  
	  	if (check_sum > 0xFF)      //进位
	  	{
	  		check_sum -= 0xFF;
	  	}
	}
	return (~check_sum);  //取反
}

/***********************************************************************************
*函数名称:   void INT_UART0(void)
*功能描述:UART0 中断服务程序
		 
*输入参数:   
*返回参数:     
*************************************************************************************/
void INT_UART0(void) interrupt INT_VECTOR_UART0
{
	u8 x;
	if(RI0==1)
	{
		// LIN接收通道状态
		if(LINFrame.State==LIN_IDLE_BREAK)
		{
			if((S0CFG1&SBF0)!=0)
			{ // Rx Break done
				UART0_LIN_ClrSBF0();
				#if (LIN_AUTO_BAUDRATE_FLAG==TRUE)
				{
					UART0_LIN_AutoBR();
					while(LIN_TXD==0);
					LINFrame.State=LIN_PID;				// 有自动校正波特时,SYNC(0x55)用于校正，不会接收，所以下一个数据是PID
				}
				#else
				{
					UART0_LIN_DisAutoBR();		
					LINFrame.State=LIN_SYNC;			// 无自动校正波特时,SYNC(0x55)会被接收，所以下一个数据是SYNC(0x55)
				}
				#endif
				LINOverTime=LIN_TIME_MAX;
			}
		}
		/**/
		else if(LINFrame.State==LIN_SYNC)
		{ // Rx SYNC done
			x=S0BUF;
			if(x == LIN_SYNC_BYTE)
			{
				LINFrame.State++;
				LINOverTime=LIN_TIME_MAX;
			}
			else
			{
				LINFrame.State=LIN_ERR;
			}
		}
		/**/
		else if(LINFrame.State==LIN_PID)
		{ // Rx PID done
			LINOverTime=LIN_TIME_MAX;
			LINFrame.PID = S0BUF;
			if((LINFrame.PID == LINSlavePID.SPIDMRx0_P)||(LINFrame.PID == LINSlavePID.SPIDMRx1_P))
			{ // PID for Master get msg 
					// Lin salve data init
					for(x = 0 ;x<8;x++)
					{
						LINFrame.Data[x] = 0x58+x ;
					}
					LINFrame.DataLength=8;
					LINFrame.Check = LIN_CalcChecksum_INT(LINFrame.PID, &LINFrame.Data[0], LINFrame.DataLength);
					LINFrame.DataInx=1;
					// send first data
					UART0_LIN_SetTX();
					S0BUF=LINFrame.Data[0];
					LINFrame.State=LIN_MASTER_RX_DATA;
			}
			else if((LINFrame.PID == LINSlavePID.SPIDMTx0_P)||(LINFrame.PID == LINSlavePID.SPIDMTx1_P))
			{// PID for Master send msg 
				LINFrame.State=LIN_MASTER_TX_DATA;
				LINFrame.DataInx=0;
			}
			else 
			{// PID error
				LINFrame.State=LIN_ERR;
			}

		}
		else if(LINFrame.State==LIN_MASTER_TX_DATA)
		{
			LINOverTime=LIN_TIME_MAX;
			LINFrame.Data[LINFrame.DataInx] = S0BUF;
			LINFrame.DataInx++;
			if(LINFrame.DataInx>=LINFrame.DataLength)
			{
				LINFrame.State++;
			}

		}
		else if(LINFrame.State==LIN_MASTER_TX_CHECKSUM)
		{
			LINOverTime=LIN_TIME_MAX;
			LINFrame.Check=S0BUF;
			LINFrame.State++;
		}
		else if(LINFrame.State==LIN_MASTER_TX_DONE)
		{
			
		}
		else
		{
			LINFrame.State=LIN_ERR;
		}
		RI0 = 0;
	}
	else
	{
		TI0 = 0;
		if(LINFrame.State==LIN_MASTER_RX_DATA)
		{
			LINOverTime=LIN_TIME_MAX;
			S0BUF=LINFrame.Data[LINFrame.DataInx];
			LINFrame.DataInx++;
			if(LINFrame.DataInx>=LINFrame.DataLength)
			{
				LINFrame.State++;
			}
		}
		else if(LINFrame.State==LIN_MASTER_RX_CHECKSUM)
		{
			LINOverTime=LIN_TIME_MAX;
			S0BUF=LINFrame.Check;
			LINFrame.State++;
			
		}
		else if(LINFrame.State==LIN_MASTER_RX_DONE)
		{
			
		}
		else
		{
			LINFrame.State=LIN_ERR;
		}
	}
}

/***********************************************************************************
*函数名称:   void INT_T0(void)
*功能描述:T0 中断服务程序
*输入参数:   
*返回参数:     
*************************************************************************************/
void INT_T0(void) interrupt INT_VECTOR_T0
{
	TH0=TIMER_12T_1ms_TH;
	TL0=TIMER_12T_1ms_TL;

	if(LedTime!=0) LedTime--;
	if(LINOverTime!=0) LINOverTime--;
}

/*************************************************
*函数名称:     void DelayXus(u8 xUs)
*功能描述:   	延时程序，单位为us
*输入参数:     u8 Us -> *1us  (1~255)
*返回参数:     
*************************************************/
void DelayXus(u8 xUs)
{
	while(xUs!=0)
	{
#if (MCU_CPUCLK>=11059200)
		_nop_();
#endif
#if (MCU_CPUCLK>=14745600)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=16000000)
		_nop_();
#endif

#if (MCU_CPUCLK>=22118400)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=24000000)
		_nop_();
		_nop_();
#endif		
#if (MCU_CPUCLK>=29491200)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=32000000)
		_nop_();
		_nop_();
#endif

		xUs--;
	}
}

/*************************************************
*函数名称:     void DelayXms(u16 xMs)
*功能描述:     延时程序，单位为ms
*输入参数:     u16 xMs -> *1ms  (1~65535)
*返回参数:     
*************************************************/
void DelayXms(u16 xMs)
{
	while(xMs!=0)
	{
		CLRWDT();
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		xMs--;
		
	}
}

/***********************************************************************************
*函数名称:   void InitUart0_LIN(void)
*功能描述:   Uart0初始化 为 LIN
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitUart0_LIN(void)
{
	
	UART0_SetAccess_S0CR1();			// 设置SFR 0xB9地址是访问S0CR1
	UART0_SetModeLIN();					// 设置串口LIN 模式				
	UART0_EnReception();				// 开启接收功能
	UART0_SetBRGFromS0BRG();			// 设置波特率来源为 S0BRG
	UART0_SetS0BRGBaudRateX2();			// 设置2x波特率
	UART0_SetS0BRGSelSYSCLK();			// 设置S0BRG时钟输入为Sysclk

	// 设置S0BRG Value
	UART0_SetS0BRGValue(S0BRG_BRGRL_9600_2X_8000000_1T);
	
	UART0_EnS0BRG();					// 开启S0BRG时钟
	
	
}

/***********************************************************************************
*函数名称:   void InitTimer0(void)
*功能描述:Timer0初始化设置
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitTimer0(void)
{
	TM_SetT0Mode_1_16BIT_TIMER();			// 设置T0模式为16位模式
	TM_SetT0Clock_SYSCLKDiv12();					// 设置T0时钟源为 SYSCLK/12
	TM_SetT0Gate_Disable();

	TM_SetT0LowByte(TIMER_12T_1ms_TL);		// 设置T0低8位
	TM_SetT0HighByte(TIMER_12T_1ms_TH);		// 设置T0高8位

	TM_EnableT0();							// 使能T0
}

/***********************************************************************************
*函数名称:   void InitInterrupt(void)
*功能描述:   中断初始化
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitInterrupt(void)
{
	INT_EnUART0();				// 使能UART0中断
	INT_EnTIMER0();				// 使能T0中断
}	

/***********************************************************************************
*函数名称:   void InitPort(void)
*功能描述:   IO配置
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitPort(void)
{
	PORT_SetP3QuasiBi(BIT0|BIT1|BIT2|BIT3);		// 设置 P30,P31,P32,P33为双向口,用于RXD/TXD,LED
	PORT_SetP4OpenDrainPu(BIT6);				// 设置 P46为开漏带上拉,用于LED
}

/***********************************************************************************
*函数名称:   void InitClock(void)
*功能描述:   时钟初始化	
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitClock(void)
{
#if (MCU_SYSCLK==8000000)
	// Default: IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
#endif

#if (MCU_SYSCLK==11059200)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
	CLK_SelIHRCO_22118400Hz();
#endif
	
#if (MCU_SYSCLK==16000000)
	// IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif

#if (MCU_SYSCLK==22118400)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SelIHRCO_22118400Hz();
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif
	

#if (MCU_CPUCLK==MCU_SYSCLK)
	CLK_SetCpuclk_Sysclk();
#else
	CLK_SetCpuclk_SysclkDiv2();
#endif

	// P45 输出 MCK/4
	//CLK_P45OC_MCKDiv4();
}

/***********************************************************************************
*函数名称:   void InitSystem(void)
*功能描述:   系统初始化
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitSystem(void)
{
	InitPort();
	InitClock();
	InitTimer0();
	InitUart0_LIN();
	InitInterrupt();
}

/*
*************************************************************************************
*  Function
*
*************************************************************************************
*/
/***********************************************************************************
*函数名称:   void LIN_Slave_StartFrame(void)
*功能描述:   LIN 开始接收
*输入参数:   
*返回参数:     
*************************************************************************************/
void LIN_Slave_StartFrame(void)
{
	// 设置S0BRG Value, 初始波特率与目标波特率不能相差太大
	UART0_SetS0BRGValue(S0BRG_BRGRL_9600_2X_8000000_1T);
	UART0_LIN_SetRX();
	UART0_LIN_WaitSYNC();

	LINFrame.State=LIN_IDLE_BREAK;
}

/***********************************************************************************
*函数名称:	uint8 LIN_CalcParity(uint8 id)
*功能描述: LIN奇偶校验计算
*输入参数:	
*返回参数:	  
*************************************************************************************/
u8 LIN_CalcParity(u8 id)
{
	u8 parity, p0,p1;
	parity=id; 
	p0=(BIT(parity,0)^BIT(parity,1)^BIT(parity,2)^BIT(parity,4))<<6;     //偶校验位
	p1=(!(BIT(parity,1)^BIT(parity,3)^BIT(parity,4)^BIT(parity,5)))<<7;  //奇校验位
	parity|=(p0|p1);
	return parity;
}

/***********************************************************************************
*函数名称:	u8 LIN_CalcChecksum(uint8 id,uint8 *data,uint8 length)
*功能描述: LIN校验和计算
*输入参数:	
*返回参数:	  
*************************************************************************************/
u8 LIN_CalcChecksum(u8 id,u8 *lindata,u8 length)
{
	u8 i;
	u16 check_sum = 0;
	//0x3C 0x3D 使用标准型校验
	if(id != 0x3c && id != 0x7d)  //使用增强型校验
	{
	 	check_sum  = id ;
	} 
	else //使用标准校验
	{
	 	check_sum = 0 ;
	}
	for (i = 0; i < length; i++) 
	{    
	  	check_sum += *(lindata++);
	  
	  	if (check_sum > 0xFF)      //进位
	  	{
	  		check_sum -= 0xFF;
	  	}
	}
	return (~check_sum);  //取反
}

/*
*************************************************************************************
*/ 

void main()
{

	InitSystem();
	
	LED_G_0 =0;LED_G_1=0;LED_R=0;
	DelayXms(1000);
	LED_G_0 =1;LED_G_1=1;LED_R=1;	

	LINSlavePID.SPIDMTx0_P=LIN_CalcParity(LIN_PID_MASTER_TX_MSG0);
	LINSlavePID.SPIDMTx1_P=LIN_CalcParity(LIN_PID_MASTER_TX_MSG1);
	LINSlavePID.SPIDMRx0_P=LIN_CalcParity(LIN_PID_MASTER_RX_MSG0);
	LINSlavePID.SPIDMRx1_P=LIN_CalcParity(LIN_PID_MASTER_RX_MSG1);

	INT_EnAll();
	LIN_Slave_StartFrame();

	while(1)
    {
		if(LedTime==0)
		{
			LedTime=100;
			LED_G_0 = !LED_G_0;	
		}
		if(LINFrame.State==LIN_MASTER_RX_DONE)
		{
			LED_G_1=0;
			DelayXms(2);
			LED_G_1=1;
			DelayXms(2);
			LIN_Slave_StartFrame();
			
		}
		if(LINFrame.State==LIN_MASTER_TX_DONE)
		{
			// 校验数据
			if(LINFrame.Check == LIN_CalcChecksum(LINFrame.PID, &LINFrame.Data[0], LINFrame.DataLength))
			{ // 校验成功
				LED_R=0;
				DelayXms(2);
				LED_R=1;
				DelayXms(2);
			}
			LIN_Slave_StartFrame();
			
		}

		if(LINFrame.State==LIN_ERR)
		{
			LIN_Slave_StartFrame();
			
		}

		if((LINFrame.State != LIN_IDLE_BREAK)&&(LINOverTime ==0))
		{
			LINFrame.State = LIN_ERR;
		}
    }

}


